//circler.jsx  version_c  by（z-）.　Photoshop CS3で動作確認
//真円形画像のものぐさクリッピング用
//円周上に3点のパスを打ったら実行。
//要・打ちたてホヤホヤ状態（アクティブで最前面）
//要・居残りのサブパスがあること

//ver_b　自宅環境（OSX10.6.7）では画像解像度72ppi以外ではズレたので座標系に修正を入れてあったのが職場（10.4.11）では再現せず。
//　　　　とりゃえず戻した。
//ver_c　ポイント2個で動くよう改善。2個目の進行方向ハンドル先端を3個目として認識可能に。


function cp(mes){
	//alert(mes);
	//$.writeln(mes);
	}

function testFunc(){ //パスアイテムをペーストして、サブパス数が増えたらアクティブなパス
	executeAction( charIDToTypeID( "copy" ), undefined, DialogModes.NO );
	executeAction( charIDToTypeID( "past" ), undefined, DialogModes.NO );
	}

function reshapeToCircle(t, l, b, r){ //選択パスアイテム上に楕円を作成
var id35 = stringIDToTypeID( "excludeIntersection" );
    var desc6 = new ActionDescriptor();
    var id36 = charIDToTypeID( "null" );
        var ref3 = new ActionReference();
        var id37 = charIDToTypeID( "Path" );
        var id38 = charIDToTypeID( "Ordn" );
        var id39 = charIDToTypeID( "Trgt" );
        ref3.putEnumerated( id37, id38, id39 );
    desc6.putReference( id36, ref3 );
    var id40 = charIDToTypeID( "T   " );
        var desc7 = new ActionDescriptor();
        var id41 = charIDToTypeID( "Top " );
        var id42 = charIDToTypeID( "#Rlt" );
        desc7.putUnitDouble( id41, id42, t );
        var id43 = charIDToTypeID( "Left" );
        var id44 = charIDToTypeID( "#Rlt" );
        desc7.putUnitDouble( id43, id44, l );
        var id45 = charIDToTypeID( "Btom" );
        var id46 = charIDToTypeID( "#Rlt" );
        desc7.putUnitDouble( id45, id46, b );
        var id47 = charIDToTypeID( "Rght" );
        var id48 = charIDToTypeID( "#Rlt" );
        desc7.putUnitDouble( id47, id48, r );
    var id49 = charIDToTypeID( "Elps" );
    desc6.putObject( id40, id49, desc7 );
executeAction( id35, desc6, DialogModes.NO );
}

function deleteFunc(){ //delete
	executeAction( charIDToTypeID( "Dlt " ), undefined, DialogModes.NO );
}

function ancFunc(){
	for(var i=0; i<3 && i<spObj.pathPoints.length; i++){ //何個であっても先頭から3個だけみる
		ancAry.push(spObj.pathPoints[i].anchor);
//		ancAry[i]=[];
//		ancAry[i].push(spObj.pathPoints[i].anchor[0]/doc.resolution*72);
//		ancAry[i].push(spObj.pathPoints[i].anchor[1]/doc.resolution*72);
		}
	if(ancAry.length==2){
		if(spObj.pathPoints[1].leftDirection[0]!=ancAry[1][0] && spObj.pathPoints[1].leftDirection[1]!=ancAry[1][1]){
			ancAry.push(spObj.pathPoints[1].leftDirection);
			}
		}
	return ancAry;
	}

function cross( ax, ay, bx, by ) {
  return (ax * by - ay * bx);
}

function getDist( ax, ay, bx, by ) {
    var dx = ax-bx;
    var dy = ay-by;
  return Math.sqrt(dx*dx + dy*dy);
}

function getLineCrossPoint( ax, ay, bx, by, px, py ) {
    var c = cross(bx-ax, by-ay, px-ax, py-ay);
    var d = getDist( ax, ay, bx, by );
    return Math.abs(c) / d;
}

function intersection_ls( a1x, a1y, a2x, a2y, b1x, b1y, b2x, b2y ) {
  var ax = a2x - a1x;
  var ay = a2y - a1y;
  var bx = b2x - b1x;
  var by = b2y - b1y;
  // 平行なら交わらない
  if( cross(a1x-a2x, a1y-a2y, b1x-b2x, b1y-b2y) == 0 ) return 0;
  var t = cross(bx,by, b1x-a1x, b1y-a1y) / cross(bx,by, ax,ay);

  return t;
}

function undoFunc(){
	//doc.activeHistoryState=undoObj; 
	doc.activeHistoryState=doc.historyStates[doc.historyStates.length-3];
	doc.activeHistoryState=doc.historyStates[doc.historyStates.length-2];
	}

function main(){
if( ! app.documents.length) return;
doc=activeDocument;
undoObj=doc.activeHistoryState; //戻す用
if( ! doc.pathItems.length) return;
for(var i=0; i<doc.pathItems.length; i++){
	splen.push(doc.pathItems[i].subPathItems.length);
	}
testFunc(); //アクティブなパスを調べるためにコピペでサブパスを追加

for(i=0; i<doc.pathItems.length; i++){ //サブパスの個数変動食い違いをみる
	if(doc.pathItems[i].subPathItems.length != splen[i]){
		
		break;
		}
	}

undoFunc();
pathObj=doc.pathItems[i];
if(i==doc.pathItems.length) return; 

//cp(pathObj.name);

var checkObj=pathObj.subPathItems.length;
var wp = pathObj.kind==PathKind.WORKPATH? 1 : 0;
if( ! checkObj) return;

spObj=pathObj.subPathItems[pathObj.subPathItems.length-1];
pathObj.select();
ancAry=ancFunc();

deleteFunc();

if(doc.pathItems.length != splen.length){
	undoFunc();pathObj.select();
	if(wp==1　|| checkObj==1){
		alert("諸事情により、作業対象外のサブパスが1つ以上必要です。\また、ターゲットのパスポイントを選択した状態で実行して下さい。n"); return;
		}
	}
pathObj=doc.pathItems[i];
if(pathObj.subPathItems.length != checkObj-1){
	undoFunc();pathObj.select();
	alert("ターゲットのパスポイントを選択した状態で実行して下さい"); return;
	}

if(ancAry.length<3) { //パスポイントは最低3個必要
	undoFunc();pathObj.select();
	alert("ターゲットとなるサブパスには最低3個のパスポイントが必要です\n\
または2個目のポイントからハンドルを伸ばして下さい\n\
（ハンドルの先端座標を3個目として判定できます）"); return;
	}

var I, J, L, M, U, V, P, Q, S, T; //点1-2、2-3の中間座標
I=ancAry[0][0];
J=ancAry[0][1];
L=ancAry[1][0];
M=ancAry[1][1];
U=ancAry[2][0];
V=ancAry[2][1];

var p1x= (I+L)/2;
var p1y = (J+M)/2;
var p2x = (L+U)/2;
var p2y = (M+V)/2;
var v1x = M-J;
var v1y = -(L-I);
var v2x = V-M;
var v2y = -(U-L);

var t = intersection_ls( p1x, p1y, p1x+v1x, p1y+v1y, p2x, p2y, p2x+v2x, p2y+v2y );
var cx = p1x + (v1x) * t;
var cy = p1y + (v1y) * t;
var rx = cx - L;
var ry = cy - M;
var R  = Math.sqrt( rx*rx + ry*ry );


reshapeToCircle(cy-R, cx-R, cy+R, cx+R);

}

var splen=[], ancAry=[], pathObj=null, spObj; 
var undoObj, doc; //戻す用

main();